#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
from PyQt4 import QtGui, QtCore

# "Urządzenia kotłowe  przykłady obliczeniowe" Henryk Rokicki Gdańsk 1996 str. 9
def wartosc_opalowa_wzor_VDI(C,H,O,S,W):
	return 339.1*C + 1214.2*(H-O/8.) + 104.7*S - 25.1*W # kJ/kg

# "Urządzenia kotłowe  przykłady obliczeniowe" Henryk Rokicki Gdańsk 1996 str. 9
def wartosc_opalowa_wzor_Gumza_Michela(C,H,N,O,S,W):
	return 340.4*C + 1017.4*H + 62.8*N + 190.9*S - 98.4*O - 25.1*W # kJ/kg

# "Urządzenia kotłowe  przykłady obliczeniowe" Henryk Rokicki Gdańsk 1996 str. 9
def wartosc_opalowa_wzor_Boie(C,H,N,O,S,W):
	return 348.3*C + 938.7*H + 104.7*S + 62.8*N - 108.*O - 24.5*W # kJ/kg

class WartoscOpalowa(QtGui.QDialog):
    def __init__(self, parent=None):
        QtGui.QDialog.__init__(self, parent)

        self.setFixedSize(400, 350)
        self.setWindowTitle(unicode("WARTOŚĆ OPAŁOWA, MJ/kg", "utf8"))

	self.vbox = QtGui.QVBoxLayout()
	
	# C
        self.C_text = QtGui.QLabel(unicode("C, %", "utf8"), self)
        self.C = QtGui.QDoubleSpinBox(self)
        self.C.setMaximum(100)
        self.C.setMinimum(0)
        self.C.setValue(63.5)
        self.connect(self.C, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.C_text)
        self.vbox.addWidget(self.C)
        
        # H
        self.H_text = QtGui.QLabel(unicode("H, %", "utf8"), self)
        self.H = QtGui.QDoubleSpinBox(self)
        self.H.setMaximum(100)
        self.H.setMinimum(0)
        self.H.setValue(4.0)
        self.connect(self.H, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.H_text)
        self.vbox.addWidget(self.H)
        
        # N
        self.N_text = QtGui.QLabel(unicode("N, %", "utf8"), self)
        self.N = QtGui.QDoubleSpinBox(self)
        self.N.setMaximum(100)
        self.N.setMinimum(0)
        self.N.setValue(1.0)
        self.connect(self.N, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.N_text)
        self.vbox.addWidget(self.N)
        
        # O
        self.O_text = QtGui.QLabel(unicode("O, %", "utf8"), self)
        self.O = QtGui.QDoubleSpinBox(self)
        self.O.setMaximum(100)
        self.O.setMinimum(0)
        self.O.setValue(7.5)
        self.connect(self.O, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.O_text)
        self.vbox.addWidget(self.O)
        
        # S
        self.S_text = QtGui.QLabel(unicode("S, %", "utf8"), self)
        self.S = QtGui.QDoubleSpinBox(self)
        self.S.setMaximum(100)
        self.S.setMinimum(0)
        self.S.setValue(1.0)
        self.connect(self.S, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.S_text)
        self.vbox.addWidget(self.S)
        
        # W
        self.W_text = QtGui.QLabel(unicode("W, %", "utf8"), self)
        self.W = QtGui.QDoubleSpinBox(self)
        self.W.setMaximum(100)
        self.W.setMinimum(0)
        self.W.setValue(7.0)
        self.connect(self.W, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.W_text)
        self.vbox.addWidget(self.W)
        
        # A
        self.A_text = QtGui.QLabel(unicode("A, %", "utf8"), self)
        self.A = QtGui.QDoubleSpinBox(self)
        self.A.setMaximum(100)
        self.A.setMinimum(0)
        self.A.setValue(16.0)
        self.connect(self.A, QtCore.SIGNAL("valueChanged(double)"), self.licz)
        self.vbox.addWidget(self.A_text)
        self.vbox.addWidget(self.A)


        self.wyniki = QtGui.QTextEdit('', self)
                        
        self.hbox = QtGui.QHBoxLayout()
        self.hbox.addLayout(self.vbox)
        self.hbox.addWidget(self.wyniki)
        
        self.setLayout(self.hbox)

	self.licz()



    def licz(self):
      
      suma = self.C.value() + self.H.value() + self.N.value() + self.O.value() + self.S.value() + self.W.value() + self.A.value()
      
      wynik = "Suma = %s%s\n\n" % (suma, "%")
      
      wynik += unicode("Wartość opalowa wzór VDI\n", "utf8")
      wynik += str(round(wartosc_opalowa_wzor_VDI(self.C.value(),self.H.value(),self.O.value(),self.S.value(),self.W.value())/1000.,2)) # MJ/kg
      wynik += "MJ/kg\n\n"
      
      wynik += unicode("Wartość opalowa wzór Gumza Michela\n", "utf8")
      wynik += str(round(wartosc_opalowa_wzor_Gumza_Michela(self.C.value(),self.H.value(), self.N.value(),self.O.value(),self.S.value(),self.W.value())/1000.,2)) # MJ/kg
      wynik += "MJ/kg\n\n"
      
      wynik += unicode("Wartość opalowa wzór Boie\n", "utf8")
      wynik += str(round(wartosc_opalowa_wzor_Boie(self.C.value(),self.H.value(), self.N.value(),self.O.value(),self.S.value(),self.W.value())/1000.,2)) # MJ/kg
      wynik += "MJ/kg\n\n" 
      
      wynik += unicode("\n\n\n\n\n\n\nautor programu: Tomasz Kamiński\n", "utf8")
      wynik += unicode("W przypadku pytań: tomasz_kaminski_gdansk@wp.pl", "utf8")
     
      self.wyniki.setText(wynik)


app = QtGui.QApplication(sys.argv)
icon = WartoscOpalowa()
icon.show()
app.exec_()

